Package biotransformer.btransformers

## Class ECBasedBTransformer

- java.lang.Object
- - biotransformer.btransformers.Biotransformer
  - - biotransformer.btransformers.ECBasedBTransformer

    public class ECBasedBTransformer
    extends Biotransformer

Author:
  Djoumbou Feunang, Yannick

### Field Summary

### Fields inherited from class biotransformer.btransformers.Biotransformer

`bSystem, enzymesByreactionGroups, enzymesList, inchiGenFactory, mapper, reactionsByGroups, reactionsHash, smiGen`

### Constructor Summary

Constructors
`ECBasedBTransformer​(BioSystem.BioSystemName bioSName)`

### Method Summary

All Methods Instance Methods Concrete Methods
`java.util.ArrayList<Biotransformation>` `applyEcBasedConjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedConjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedConjugations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedDeconjuations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nrOfSteps)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedDeconjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedDeconjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedDeconjugations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedTransformations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedTransformations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedTransformationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps)`
`java.util.ArrayList<Biotransformation>` `applyEcBasedTransformationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, double scoreThreshold)`
`boolean` `isConjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)`
`boolean` `isDeconjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)`
`void` `printStatistics()`
`void` `simulateECBasedMetabolismAndSaveToSDF​(java.lang.String sdfFileName, int nrOfSteps, java.lang.Double scoreThreshold, java.lang.String outputFolder, boolean annotate)`
`void` `simulateECBasedMetabolismAndSaveToSDF​(org.openscience.cdk.interfaces.IAtomContainerSet containers, int nrOfSteps, java.lang.Double scoreThreshold, java.lang.String outputFolder, boolean annotate)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainer molecule, boolean preprocess, boolean filter, int nrOfSteps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainerSet molecules, boolean preprocess, boolean filter, int nrOfSteps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainer molecule, boolean preprocess, boolean filter, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainerSet molecules, boolean preprocess, boolean filter, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedPhaseIMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainer molecule, boolean preprocess, boolean filter, int nrOfSteps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedPhaseIMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainerSet molecules, boolean preprocess, boolean filter, int nrOfSteps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedPhaseIMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainer molecule, boolean preprocess, boolean filter, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateECBasedPhaseIMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainerSet molecules, boolean preprocess, boolean filter, java.lang.Double scoreThreshold)`

### Methods inherited from class biotransformer.btransformers.Biotransformer

`applyPathwaySpecificBiotransformationChain, applyPathwaySpecificBiotransformations, applyPathwaySpecificBiotransformations, applyPathwaySpecificBiotransformationsChain, applyPathwaySpecificBiotransformationsChain, applyReactionAndReturnBiotransformations, applyReactionAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionChain, applyReactionChain, applyReactions, applyReactions, applyReactionsAndReturnBiotransformations, applyReactionsAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsFromContainersAndReturnBiotransformations, extractProductsFromBiotransformations, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, generateAllMetabolitesFromAtomContainer, generateAllMetabolitesFromAtomContainer, generateAllMetabolitesFromAtomContainerViaTransformationAtAllLocations, getBioSystemName, getReactionsList, getSmiParser, isValidSubstrate, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzymes, metabolizeWithEnzymes, metabolizeWithEnzymesBreadthFirst, metabolizeWithEnzymesBreadthFirst, metabolizeWithEnzymesDephtFirst, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSDF`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ECBasedBTransformer

    public ECBasedBTransformer​(BioSystem.BioSystemName bioSName)
                        throws java.io.IOException,
                               org.json.simple.parser.ParseException,
                               org.openscience.cdk.exception.CDKException

Throws:
  `org.json.simple.parser.ParseException`
  `java.io.IOException`
  `org.openscience.cdk.exception.CDKException`
  `java.net.URISyntaxException`

### Method Detail

#### applyEcBasedDeconjuations

    public java.util.ArrayList<Biotransformation> applyEcBasedDeconjuations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                            boolean preprocess,
                                                                            boolean filter,
                                                                            int nrOfSteps)
                                                                     throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nrOfSteps` - - number of steps
Returns:
  an arraylist of biotransformations, which are instances of the EC-based metabolic reactions applied to the target, with a threshold of 0.0
Throws:
  `java.lang.Exception`

#### applyEcBasedDeconjugations

    public java.util.ArrayList<Biotransformation> applyEcBasedDeconjugations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                             boolean preprocess,
                                                                             boolean filter,
                                                                             int nr_of_steps,
                                                                             double scoreThreshold)
                                                                      throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `scoreThreshold` - - minimum score threshold for selected metbaolic reactions
Returns:
  an arraylist of biotransformations, which are instances of the EC-based metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### applyEcBasedDeconjuationsChain

    public java.util.ArrayList<Biotransformation> applyEcBasedDeconjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int nr_of_steps)
                                                                          throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the EC-based metabolic reactions applied to the target, with the minimum threshold of 0.0
Throws:
  `java.lang.Exception` - - Throw an exception

#### applyEcBasedDeconjuationsChain

    public java.util.ArrayList<Biotransformation> applyEcBasedDeconjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int nr_of_steps,
                                                                                 double scoreThreshold)
                                                                          throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the EC-based metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### applyEcBasedTransformations

    public java.util.ArrayList<Biotransformation> applyEcBasedTransformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                              boolean preprocess,
                                                                              boolean filter)
                                                                       throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
Returns:
  an arraylist of biotransformations, which are instances of the EC-based metabolic reactions applied to the target, with a threshold of 0.0
Throws:
  `java.lang.Exception` - - throw any exception

#### applyEcBasedTransformations

    public java.util.ArrayList<Biotransformation> applyEcBasedTransformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                              boolean preprocess,
                                                                              boolean filter,
                                                                              double scoreThreshold)
                                                                       throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `scoreThreshold` - - minimum threshold for reaction scores
Returns:
  an arraylist of biotransformations, which are instances of the EC-based metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### applyEcBasedTransformationsChain

    public java.util.ArrayList<Biotransformation> applyEcBasedTransformationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                   boolean preprocess,
                                                                                   boolean filter,
                                                                                   int nr_of_steps)
                                                                            throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the EC-based metabolic reactions applied to the target, with the minimum threshold of 0.0
Throws:
  `java.lang.Exception` - - throw any exception

#### applyEcBasedTransformationsChain

    public java.util.ArrayList<Biotransformation> applyEcBasedTransformationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                   boolean preprocess,
                                                                                   boolean filter,
                                                                                   int nr_of_steps,
                                                                                   double scoreThreshold)
                                                                            throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the EC-based metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception` - - throw any exception

#### applyEcBasedConjugations

    public java.util.ArrayList<Biotransformation> applyEcBasedConjugations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                           boolean preprocess,
                                                                           boolean filter,
                                                                           double scoreThreshold)
                                                                    throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
  `scoreThreshold` - - minimum threshold for reaction scores
Returns:
  an arraylist of biotransformations, which are instances of the EC-based metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### applyEcBasedConjuationsChain

    public java.util.ArrayList<Biotransformation> applyEcBasedConjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                               boolean preprocess,
                                                                               boolean filter,
                                                                               int nr_of_steps)
                                                                        throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the EC-based metabolic reactions applied to the target, with the minimum threshold of 0.0
Throws:
  `java.lang.Exception`

#### applyEcBasedConjuationsChain

    public java.util.ArrayList<Biotransformation> applyEcBasedConjuationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                               boolean preprocess,
                                                                               boolean filter,
                                                                               int nr_of_steps,
                                                                               double scoreThreshold)
                                                                        throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the EC-based metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### simulateECBasedPhaseIMetabolismStep

    public java.util.ArrayList<Biotransformation> simulateECBasedPhaseIMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainer molecule,
                                                                                      boolean preprocess,
                                                                                      boolean filter,
                                                                                      java.lang.Double scoreThreshold)

#### simulateECBasedPhaseIMetabolismStep

    public java.util.ArrayList<Biotransformation> simulateECBasedPhaseIMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainerSet molecules,
                                                                                      boolean preprocess,
                                                                                      boolean filter,
                                                                                      java.lang.Double scoreThreshold)
                                                                               throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedPhaseIMetabolismChain

    public java.util.ArrayList<Biotransformation> simulateECBasedPhaseIMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainer molecule,
                                                                                       boolean preprocess,
                                                                                       boolean filter,
                                                                                       int nrOfSteps,
                                                                                       java.lang.Double scoreThreshold)
                                                                                throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedPhaseIMetabolismChain

    public java.util.ArrayList<Biotransformation> simulateECBasedPhaseIMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainerSet molecules,
                                                                                       boolean preprocess,
                                                                                       boolean filter,
                                                                                       int nrOfSteps,
                                                                                       java.lang.Double scoreThreshold)
                                                                                throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedMetabolismStep

    public java.util.ArrayList<Biotransformation> simulateECBasedMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainer molecule,
                                                                                boolean preprocess,
                                                                                boolean filter,
                                                                                java.lang.Double scoreThreshold)
                                                                         throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedMetabolismStep

    public java.util.ArrayList<Biotransformation> simulateECBasedMetabolismStep​(org.openscience.cdk.interfaces.IAtomContainerSet molecules,
                                                                                boolean preprocess,
                                                                                boolean filter,
                                                                                java.lang.Double scoreThreshold)
                                                                         throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedMetabolismChain

    public java.util.ArrayList<Biotransformation> simulateECBasedMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainer molecule,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int nrOfSteps,
                                                                                 java.lang.Double scoreThreshold)
                                                                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedMetabolismChain

    public java.util.ArrayList<Biotransformation> simulateECBasedMetabolismChain​(org.openscience.cdk.interfaces.IAtomContainerSet molecules,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int nrOfSteps,
                                                                                 java.lang.Double scoreThreshold)
                                                                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedMetabolismAndSaveToSDF

    public void simulateECBasedMetabolismAndSaveToSDF​(org.openscience.cdk.interfaces.IAtomContainerSet containers,
                                                      int nrOfSteps,
                                                      java.lang.Double scoreThreshold,
                                                      java.lang.String outputFolder,
                                                      boolean annotate)
                                               throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateECBasedMetabolismAndSaveToSDF

    public void simulateECBasedMetabolismAndSaveToSDF​(java.lang.String sdfFileName,
                                                      int nrOfSteps,
                                                      java.lang.Double scoreThreshold,
                                                      java.lang.String outputFolder,
                                                      boolean annotate)
                                               throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### isDeconjugationCandidate

    public boolean isDeconjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)
                                     throws ambit2.smarts.query.SMARTSException,
                                            org.openscience.cdk.exception.CDKException,
                                            java.io.IOException

Throws:
  `ambit2.smarts.query.SMARTSException`
  `org.openscience.cdk.exception.CDKException`
  `java.io.IOException`

#### isConjugationCandidate

    public boolean isConjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)
                                   throws ambit2.smarts.query.SMARTSException,
                                          org.openscience.cdk.exception.CDKException,
                                          java.io.IOException

Throws:
  `ambit2.smarts.query.SMARTSException`
  `org.openscience.cdk.exception.CDKException`
  `java.io.IOException`

#### printStatistics

    public void printStatistics()